﻿using Microsoft.Extensions.Options;
using System;
using System.Collections.Generic;

namespace SlnMesnac.Config
{
    /// <summary>
    /// 系统配置
    /// </summary>
    public class AppConfig : IOptions<AppConfig>
    {
        /// <summary>
        /// 日志文件路径
        /// </summary>
        public string logPath { get; set; }
        
        /// <summary>
        /// MCS 开仓地址
        /// </summary>
        public string mcsOpenAddr { get; set; }
        
        /// <summary>
        /// CWSS 开仓地址
        /// </summary>
        public string cwssOpenAddr { get; set; }
        
        /// <summary>
        /// Sql连接配置 
        /// </summary>
        public List<SqlConfig> sqlConfig { get; set; }
        
        /// <summary>
        /// PLC连接配置
        /// </summary>
        public List<PlcConfig> plcConfig { get; set; }
        
        public AppConfig Value => this;
    }
}
